//font.c by st0ne
//Create a font of 9 characters from the 19 characters text

#include <stdio.h>
#define byte unsigned char

#define SIZ 16
#define WID (SIZ*9)

//Permutation of letters, between 0 and 5039
//this one works fine...
#define P 21098

FILE	*in,*out;
byte	d;
long	i,j,k;
long    p,t=5040;
byte    data[WID*36];
byte    vect[8]={0,7,9,10,11,13,14,15};	//TLFORSCH
byte    perm[8]={0,1,2,3,4,5,6,7};

main (int argc, char *argv[]) {
  if (argc==3) {
    in=fopen (argv[1],"rb");
    out=fopen (argv[2],"wb");
  } else {
    printf ("Usage : font <in> <out>\n");
    exit(0);
  }

  //Init permutation array
  p=P;
  for (k=0; k<7; k++) {
    perm[k]=p/t;
    p=p-perm[k]*t;
    t=t/(7-k);
  }
  perm[7]=0;
  //printf("%d ",perm[0]);
  for (k=1; k<8; k++) {
    for (i=0; i<=perm[k]; i++) {
      for (j=0; j<k; j++) if (i==perm[j]) perm[k]++;
    }
    //printf("%ld ",perm[k]);
  }
  //printf("\n");

  //Clear data
  for (j=0; j<WID*36; j++) data[j]=7;
    
  //Copy letters according to permutation
  for (i=0; i<8; i++) {
    for (j=0; j<36; j++) {
      fseek(in,303*j+SIZ*vect[perm[i]],SEEK_SET);
      fread(&data[SIZ*j+36*SIZ*i],1,SIZ,in);
    }
  }

  fwrite(data,1,WID*36,out);
  printf("Font OK : %ld bytes\n",ftell(out));

  exit(0);
  return;
}